package gkp.yue.ddd.dice;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.view.MotionEvent;

/**
 * ɫӵȾͼ
 * @author Yue Jinbiao
 *
 */
class DiceSurfaceView extends GLSurfaceView {

	private DiceRenderer mRenderer = null;
	private float mPreviousX = 0;
	private float mPreviousY = 0;

	public DiceSurfaceView(Context context) {
		super(context);
		// Ⱦ
		mRenderer = new DiceRenderer(this);
		setRenderer(mRenderer);
		// 淽ʽ
		setAutoRender(false);
		this.requestRender();
	}

	@Override
	public boolean onTouchEvent(MotionEvent e) {
		float x = e.getX();
		float y = e.getY();
		//ת귽
		y = -y;

		switch (e.getAction()) {
		case MotionEvent.ACTION_MOVE:
			float dx = x - mPreviousX;
			float dy = y - mPreviousY;
			mRenderer.onTouchMove(dx, dy);
		case MotionEvent.ACTION_DOWN:
//			Log.i("tg","touch down/" + x + "/" + y);
			this.mPreviousX = x;
			this.mPreviousY = y;
			break;
		case MotionEvent.ACTION_UP:
//			Log.i("tg","touch up/" + x + "/" + y);
			this.mPreviousX = 0;
			this.mPreviousY = 0;
			setAutoRender(true);
			this.mRenderer.startRotate();
			break;
		}
		this.requestRender();
		return true;
	}
	/**
	 * ǷԶȾ
	 * @param auto
	 */
	public void setAutoRender(boolean auto){
		// RENDERMODE_WHEN_DIRTY-иıʱػ-requestRender()
		// RENDERMODE_CONTINUOUSLY -Զػ棨Ĭϣ
		if(auto){
			setRenderMode(GLSurfaceView.RENDERMODE_CONTINUOUSLY);
		}else{
			setRenderMode(GLSurfaceView.RENDERMODE_WHEN_DIRTY);
		}
	}

	//ñ
	public void resetBackground(int optionalBg){
		TextureManager.bgIndex = optionalBg;
		this.requestRender();
	}
}
